# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 5000
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
#include <string.h>
#ifdef wx_x
extern char *malloc();
#endif
#define Return(x) return x;

int lex_buffer_length = 0;
char *lex_buffer = NULL;
int lex_string_ptr = 0;
int lex_read_from_string = 0;

#undef input
#undef unput
/* #undef output */

void LexFromFile(fd)
FILE *fd;
{
  lex_read_from_string = 0;
  yyin = fd;
}

void LexFromString(buffer)
char *buffer;
{
  lex_read_from_string = 1;
  lex_buffer = buffer;
  lex_buffer_length = strlen(buffer);
  lex_string_ptr = 0;
}

char input()
{
  if (lex_read_from_string)
  {
    if (lex_string_ptr == lex_buffer_length)
      return 0;
    else
    {
      char c = lex_buffer[lex_string_ptr];
      lex_string_ptr ++;
      if (c == 10)
        yylineno ++;
      return c;
    }
  }
  else
  {
    return (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar);
  }
}



unput(c)
char c;
{
  if (lex_read_from_string)
  {
    if (c == 10)
      yylineno --;
    lex_string_ptr --;
  }
  else
  {
    yytchar= (c);
    if(yytchar=='\n') yylineno--;
    *yysptr++=yytchar;
  }
}

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
		  {yylval.s = strdup(yytext); Return(INTEGER);}
break;
case 2:
	  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 3:
	  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 4:
	  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 5:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 6:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 7:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 8:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 9:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 10:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 11:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 12:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 13:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 14:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 15:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 16:
	                  {yylval.s = strdup(yytext); Return(WORD);}
break;
case 17:
          {int len = strlen(yytext);
                                   yytext[len-1] = 0;
                                   yylval.s = strdup(yytext+1); 
                                   Return(WORD);}
break;
case 18:
 {yylval.s = strdup(yytext); Return(STRING);}
break;
case 19:
			  Return(OPEN);
break;
case 20:
			  Return(CLOSE);
break;
case 21:
			  Return(COMMA);
break;
case 22:
                              Return(OPEN_SQUARE);
break;
case 23:
                              Return(CLOSE_SQUARE);
break;
case 24:
                              Return(EQUALS);
break;
case 25:
			  Return(PERIOD);
break;
case 26:
			  ;
break;
case 27:
			  ;
break;
case 28:
   {
         int ch;
         while ((ch = input() != '\n') && ch != EOF)
         {}
       }
break;
case 29:
   {       loop:
                          while (input() != '*');
                          switch (input())
                                  {
                                  case '/': break;
                                  case '*': unput('*');
                                  default: goto loop;
                                  }
                          }
break;
case 30:
			  Return(ERROR);
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

30,
0,

26,
30,
0,

27,
0,

30,
0,

30,
0,

30,
0,

30,
0,

19,
30,
0,

20,
30,
0,

7,
30,
0,

5,
30,
0,

21,
30,
0,

6,
30,
0,

25,
30,
0,

8,
30,
0,

1,
30,
0,

28,
30,
0,

13,
30,
0,

9,
24,
30,
0,

14,
30,
0,

3,
30,
0,

2,
30,
0,

22,
30,
0,

23,
30,
0,

16,
0,

18,
0,

4,
0,

17,
0,

1,
0,

29,
0,

11,
0,

10,
0,

15,
0,

12,
0,

3,
0,

2,
0,

18,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,7,	
1,3,	1,8,	30,43,	0,0,	
1,9,	1,10,	1,11,	1,12,	
1,13,	1,14,	1,15,	1,16,	
1,17,	1,18,	13,35,	13,35,	
13,35,	13,35,	13,35,	13,35,	
13,35,	13,35,	13,35,	13,35,	
1,19,	1,20,	1,21,	1,22,	
1,23,	6,27,	1,24,	8,32,	
17,36,	2,6,	20,37,	21,39,	
2,8,	22,40,	0,0,	44,43,	
2,10,	2,11,	2,12,	7,28,	
2,14,	0,0,	2,16,	2,17,	
0,0,	0,0,	20,38,	7,28,	
7,28,	0,0,	0,0,	0,0,	
1,25,	1,3,	1,26,	2,19,	
2,20,	2,21,	2,22,	2,23,	
9,33,	33,0,	0,0,	31,44,	
0,0,	0,0,	0,0,	0,0,	
9,33,	9,33,	0,0,	0,0,	
7,29,	7,28,	0,0,	0,0,	
0,0,	7,28,	0,0,	0,0,	
0,0,	7,28,	0,0,	7,28,	
0,0,	28,31,	7,28,	2,25,	
30,31,	2,26,	43,31,	0,0,	
0,0,	9,33,	9,33,	31,31,	
0,0,	0,0,	9,34,	0,0,	
0,0,	0,0,	9,33,	7,28,	
9,33,	0,0,	0,0,	9,33,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
9,33,	44,31,	0,0,	0,0,	
0,0,	0,0,	7,30,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	9,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	7,31,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,41,	0,0,	23,0,	
23,0,	23,0,	23,0,	23,0,	
0,0,	23,0,	23,0,	23,41,	
0,0,	0,0,	23,41,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
23,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	23,0,	23,41,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	23,0,	23,0,	23,0,	
23,0,	0,0,	23,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	23,0,	23,0,	23,0,	
23,0,	23,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,42,	0,0,	24,0,	24,0,	
24,0,	24,0,	24,0,	0,0,	
24,0,	24,0,	24,42,	0,0,	
0,0,	24,42,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	24,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	24,0,	24,42,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
24,0,	24,0,	24,0,	24,0,	
0,0,	24,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
24,0,	24,0,	24,0,	24,0,	
24,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,32,	
0,0,	32,0,	32,0,	32,0,	
32,0,	32,0,	0,0,	32,0,	
32,0,	32,32,	0,0,	0,0,	
32,32,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	32,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
32,0,	32,32,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	32,0,	
32,0,	32,0,	32,0,	0,0,	
32,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	32,0,	
32,0,	32,0,	32,0,	32,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	0,0,	0,0,	
41,0,	41,0,	41,0,	41,0,	
41,0,	0,0,	41,0,	41,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	41,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	41,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	41,0,	41,0,	
41,0,	41,0,	0,0,	41,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	41,0,	41,0,	
41,0,	41,0,	41,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	0,0,	0,0,	42,0,	
42,0,	42,0,	42,0,	42,0,	
0,0,	42,0,	42,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
42,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	42,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	42,0,	42,0,	42,0,	
42,0,	0,0,	42,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	42,0,	42,0,	42,0,	
42,0,	42,0,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-36,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+4,	0,		yyvstop+8,
yycrank+-78,	0,		yyvstop+10,
yycrank+4,	0,		yyvstop+12,
yycrank+-99,	0,		yyvstop+14,
yycrank+0,	0,		yyvstop+16,
yycrank+0,	0,		yyvstop+19,
yycrank+0,	0,		yyvstop+22,
yycrank+2,	0,		yyvstop+25,
yycrank+0,	0,		yyvstop+28,
yycrank+0,	yysvec+13,	yyvstop+31,
yycrank+0,	0,		yyvstop+34,
yycrank+26,	0,		yyvstop+37,
yycrank+0,	yysvec+13,	yyvstop+40,
yycrank+0,	0,		yyvstop+43,
yycrank+25,	0,		yyvstop+46,
yycrank+9,	0,		yyvstop+49,
yycrank+12,	0,		yyvstop+53,
yycrank+-202,	0,		yyvstop+56,
yycrank+-329,	0,		yyvstop+59,
yycrank+0,	0,		yyvstop+62,
yycrank+0,	0,		yyvstop+65,
yycrank+0,	0,		yyvstop+68,
yycrank+-1,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+70,
yycrank+-4,	yysvec+7,	0,	
yycrank+-11,	yysvec+7,	0,	
yycrank+-456,	0,		yyvstop+72,
yycrank+-9,	yysvec+9,	0,	
yycrank+0,	0,		yyvstop+74,
yycrank+0,	yysvec+13,	yyvstop+76,
yycrank+0,	0,		yyvstop+78,
yycrank+0,	0,		yyvstop+80,
yycrank+0,	0,		yyvstop+82,
yycrank+0,	0,		yyvstop+84,
yycrank+0,	0,		yyvstop+86,
yycrank+-583,	yysvec+23,	yyvstop+88,
yycrank+-710,	yysvec+24,	yyvstop+90,
yycrank+-6,	yysvec+7,	yyvstop+92,
yycrank+-41,	yysvec+7,	0,	
0,	0,	0};
struct yywork *yytop = yycrank+837;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,'#' ,'#' ,01  ,01  ,047 ,
01  ,01  ,'#' ,'+' ,01  ,'-' ,'#' ,'#' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,0134,01  ,01  ,'A' ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
